#include "stdint.h"

enum Board_States_t {
    LIGHT_OFF = 0u,
    POTENTIAL_MOVE,
    POTENTIAL_TAKE,
    SUGGESTED_MOVE,
    ERROR_MOVE,
    PIECE_ORIGIN,
    PIECE_NEEDS_TO_BE_HERE,
    POTENTIAL_CASTLE,
    PIECE_NEEDS_TO_BE_REMOVED,
    CONVERTING_PAWN,
};

#define PAWN_WHITE      0u
#define PAWN_BLACK      1u
#define KING_WHITE      2u
#define KING_BLACK      3u
#define ROOK_WHITE      4u
#define ROOK_BLACK      5u
#define KNIGHT_WHITE    6u
#define KNIGHT_BLACK    7u
#define BISHOP_WHITE    8u
#define BISHOP_BLACK    9u
#define QUEEN_WHITE     10u
#define QUEEN_BLACK     11u
#define SQUARE_EMPTY    12u


// enum Game_State_t {
//     GAME_STATE_P1_TURN_BEGINING = 0u,
//     GAME_STATE_P1_TURN_IN_PROGRESS,
//     GAME_STATE_P1_TURN_TAKING,
//     GAME_STATE_P2_TURN_BEGINING,
//     GAME_STATE_P2_TURN_IN_PROGRESS,
//     GAME_STATE_P2_TURN_TAKING,
//     GAME_STATE_ERROR_DETECTED,
// //All games states from over on, correspond to states of the game being over
//     GAME_STATE_OVER,
//     GAME_STATE_OVER_WHITE_WIN,
//     GAME_STATE_OVER_BLACK_WIN,
//     GAME_STATE_OVER_STALE_MATE,
// };
#define GAME_STATE_IDLE                 0u
#define GAME_STATE_P1_TURN_BEGINING     1u
#define GAME_STATE_P1_TURN_IN_PROGRESS  2u
#define GAME_STATE_P1_TURN_TAKING       3u
#define GAME_STATE_P2_TURN_BEGINING     4u
#define GAME_STATE_P2_TURN_IN_PROGRESS  5u
#define GAME_STATE_P2_TURN_TAKING       6u
#define GAME_STATE_ERROR_DETECTED       7u
//All games states from over on, correspond to states of the game being over
#define GAME_STATE_OVER                 8u
#define GAME_STATE_OVER_WHITE_WIN       8u
#define GAME_STATE_OVER_BLACK_WIN       9u
#define GAME_STATE_OVER_STALE_MATE      10u

#define WHITE_TURN true
#define BLACK_TURN false

enum Turn_State_t {
    BEGINNING = 0,
    IN_PROGRESS,
    FINALIZING,
};

struct Game_State_t {
    bool game_over = false;
    bool error_detected = false;
    bool player_turn = WHITE_TURN;
    Turn_State_t turn_state = BEGINNING;
};

void chess_board_init(void);
void Board_Changed(uint8_t current_binary_board[12]);
void Board_get_lights_and_state(uint8_t board_lights[12][8], uint8_t board_state[12][8]);
Game_State_t Board_get_game_state(void);
